-- has FK on station
DELETE FROM messung
    WHERE stationid NOT IN (
        SELECT stationid FROM station
            WHERE gewaesserid = (SELECT gewaesserid FROM gewaesser WHERE name='Elbe')
                AND km BETWEEN :a AND :b);
--                   (SELECT km FROM bezugspegel WHERE name='Torgau')
--                AND
--                   (SELECT km FROM bezugspegel WHERE name='Aken'));
    -- WHERE stationid NOT IN (
    --     SELECT stationid FROM station
    --         WHERE bezugspegelid IN
    --             (SELECT bezugspegelid FROM bezugspegel WHERE 
    -- 		    gewaesserid = (SELECT gewaesserid FROM gewaesser WHERE name='Elbe')
    -- 		    AND km BETWEEN
    --                     (SELECT km FROM bezugspegel WHERE name='Torgau')
    --                 AND
    --                     (SELECT km FROM bezugspegel WHERE name='Aken')));
    -- using bezugspegelid might not a good idea as it is _not_ NOT NULL
    -- too many data may be deleted

-- has FK on station
DELETE FROM hpeilung
    WHERE stationid NOT IN (
        SELECT stationid FROM station
            WHERE gewaesserid = (SELECT gewaesserid FROM gewaesser WHERE name='Elbe')
                AND km BETWEEN :a AND :b);
                -- AND km BETWEEN
                --    (SELECT km FROM bezugspegel WHERE name='Torgau')
                -- AND
                --    (SELECT km FROM bezugspegel WHERE name='Aken'));

-- has FK on station
DELETE FROM sohltest
    WHERE stationid NOT IN (
        SELECT stationid FROM station
            WHERE gewaesserid = (SELECT gewaesserid FROM gewaesser WHERE name='Elbe')
                AND km BETWEEN :a AND :b);
                -- AND km BETWEEN
                --    (SELECT km FROM bezugspegel WHERE name='Torgau')
                -- AND
                --    (SELECT km FROM bezugspegel WHERE name='Aken'));

-- has FK on station
DELETE FROM mpeilung
    WHERE stationid NOT IN (
        SELECT stationid FROM station
            WHERE gewaesserid = (SELECT gewaesserid FROM gewaesser WHERE name='Elbe')
                AND km BETWEEN :a AND :b);
                -- AND km BETWEEN
                --    (SELECT km FROM bezugspegel WHERE name='Torgau')
                -- AND
                --    (SELECT km FROM bezugspegel WHERE name='Aken'));

-- has FK on bezugspegel and on gewaesser (the latter is NOT NULL)
DELETE FROM station
    WHERE gewaesserid <> (SELECT gewaesserid FROM gewaesser WHERE name='Elbe')
        OR km NOT BETWEEN :a AND :b;
	-- AND km NOT BETWEEN
        --     (SELECT km FROM bezugspegel WHERE name='Torgau')
        --     AND
        --     (SELECT km FROM bezugspegel WHERE name='Aken');

-- has FK on gewaesser
DELETE FROM bezugspegel
    WHERE bezugspegelid NOT IN 
        (SELECT bezugspegelid FROM station WHERE bezugspegelid IS NOT NULL);
    -- WHERE gewaesserid <> (SELECT gewaesserid FROM gewaesser WHERE name='Elbe')
    --     AND km NOT BETWEEN
    --             (SELECT km FROM bezugspegel WHERE name='Torgau')
    --         AND
    --             (SELECT km FROM bezugspegel WHERE name='Aken');

DELETE FROM gewaesser WHERE name <> 'Elbe';

-- tables not needed in D4E river
DROP TABLE bild;
DROP TABLE probebild;
